import { NonEmptyArray, PredIndexed } from './_types';
export declare function groupBy<T>(items: readonly T[], fn: (item: T) => PropertyKey): Record<PropertyKey, NonEmptyArray<T>>;
export declare function groupBy<T>(fn: (item: T) => PropertyKey): (array: readonly T[]) => Record<PropertyKey, NonEmptyArray<T>>;
declare type Out<Value, Key extends PropertyKey = PropertyKey> = string extends Key ? Record<Key, NonEmptyArray<Value>> : number extends Key ? Record<Key, NonEmptyArray<Value>> : symbol extends Key ? Record<Key, NonEmptyArray<Value>> : Partial<Record<Key, NonEmptyArray<Value>>>;
export declare namespace groupBy {
    function indexed<T, K>(array: readonly T[], fn: PredIndexed<T, PropertyKey>): Record<string, NonEmptyArray<T>>;
    function indexed<T, K>(fn: PredIndexed<T, PropertyKey>): (array: readonly T[]) => Record<string, NonEmptyArray<T>>;
    function strict<Value, Key extends PropertyKey = PropertyKey>(items: readonly Value[], fn: (item: Value) => Key): Out<Value, Key>;
    function strict<Value, Key extends PropertyKey = PropertyKey>(fn: (item: Value) => Key): (array: readonly Value[]) => Out<Value, Key>;
    namespace strict {
        function indexed<Value, Key extends PropertyKey = PropertyKey>(array: readonly Value[], fn: PredIndexed<Value, Key>): Out<Value, Key>;
        function indexed<Value, Key extends PropertyKey = PropertyKey>(fn: PredIndexed<Value, Key>): (array: readonly Value[]) => Out<Value, Key>;
    }
}
export {};
//# sourceMappingURL=groupBy.d.ts.map