import { groupBy } from './groupBy';
import { pipe } from './pipe';
var array = [
    { a: 1, b: 1 },
    { a: 1, b: 2 },
    { a: 2, b: 1 },
    { a: 1, b: 3 },
];
var expected = {
    1: [
        { a: 1, b: 1 },
        { a: 1, b: 2 },
        { a: 1, b: 3 },
    ],
    2: [{ a: 2, b: 1 }],
};
var array2 = [
    { a: 'cat', b: 123 },
    { a: 'dog', b: 456 },
];
describe('data first', function () {
    test('groupBy', function () {
        expect(groupBy(array, function (x) { return x.a; })).toEqual(expected);
    });
    test('groupBy.indexed', function () {
        expect(groupBy.indexed(array, function (x) { return x.a; })).toEqual(expected);
    });
});
describe('data last', function () {
    test('groupBy', function () {
        expect(pipe(array, groupBy(function (x) { return x.a; }))).toEqual(expected);
    });
    test('groupBy.indexed', function () {
        expect(pipe(array, groupBy.indexed(function (x) { return x.a; }))).toEqual(expected);
    });
});
describe('Result key types', function () {
    test('Union of string literals', function () {
        var data = groupBy.strict(array2, function (x) { return x.a; });
        var result = true;
        expect(result).toEqual(true);
    });
    test('Union of number literals', function () {
        var data = groupBy.strict(array2, function (x) { return x.b; });
        var result = true;
        expect(result).toEqual(true);
    });
    test('string', function () {
        var data = groupBy.strict(array2, function (x) { return x.a; });
        var result = true;
        expect(result).toEqual(true);
    });
    test('number', function () {
        var data = groupBy.strict(array2, function (x) { return x.b; });
        var result = true;
        expect(result).toEqual(true);
    });
    test('string | number', function () {
        var data = groupBy.strict(array2, function (x) { return x.b; });
        var result = true;
        expect(result).toEqual(true);
    });
});
